# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Resource types

* [`dsc_xadcscertificationauthority`](#dsc_xadcscertificationauthority): The DSC xAdcsCertificationAuthority resource type. Automatically generated from version 1.0.0.0
* [`dsc_xadcsonlineresponder`](#dsc_xadcsonlineresponder): The DSC xAdcsOnlineResponder resource type. Automatically generated from version 1.0.0.0
* [`dsc_xadcswebenrollment`](#dsc_xadcswebenrollment): The DSC xAdcsWebEnrollment resource type. Automatically generated from version 1.0.0.0

## Resource types

### <a name="dsc_xadcscertificationauthority"></a>`dsc_xadcscertificationauthority`

The DSC xAdcsCertificationAuthority resource type.
Automatically generated from version 1.0.0.0

#### Properties

The following properties are available in the `dsc_xadcscertificationauthority` type.

##### `dsc_cacommonname`

Data type: `Optional[String]`

Specifies the certification authority common name.

##### `dsc_cadistinguishednamesuffix`

Data type: `Optional[String]`

Specifies the certification authority distinguished name suffix.

##### `dsc_certfile`

Data type: `Optional[String]`

Specifies the file name of certification authority PKCS 12 formatted certificate file.

##### `dsc_certificateid`

Data type: `Optional[String]`

Specifies the thumbprint or serial number of certification authority certificate.

##### `dsc_cryptoprovidername`

Data type: `Optional[String]`

The name of the cryptographic service provider  or key storage provider that is used to generate or store the private key for the CA.

##### `dsc_databasedirectory`

Data type: `Optional[String]`

Specifies the folder location of the certification authority database.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

Specifies whether the Certificate Authority should be installed or uninstalled.

##### `dsc_hashalgorithmname`

Data type: `Optional[String]`

Specifies the signature hash algorithm used by the certification authority.

##### `dsc_ignoreunicode`

Data type: `Optional[Boolean]`

Specifies that Unicode characters are allowed in certification authority name string.

##### `dsc_keycontainername`

Data type: `Optional[String]`

Specifies the name of an existing private key container.

##### `dsc_keylength`

Data type: `Optional[Integer[0, 4294967295]]`

Specifies the name of an existing private key container.

##### `dsc_logdirectory`

Data type: `Optional[String]`

Specifies the folder location of the certification authority database log.

##### `dsc_outputcertrequestfile`

Data type: `Optional[String]`

Specifies the folder location for certificate request file.

##### `dsc_overwriteexistingcainds`

Data type: `Optional[Boolean]`

Specifies that the computer object in the Active Directory Domain Service domain should be overwritten with the same computer name.

##### `dsc_overwriteexistingdatabase`

Data type: `Optional[Boolean]`

Specifies that the existing certification authority database should be overwritten.

##### `dsc_overwriteexistingkey`

Data type: `Optional[Boolean]`

Overwrite existing key container with the same name

##### `dsc_parentca`

Data type: `Optional[String]`

Specifies the configuration string of the parent certification authority that will certify this CA.

##### `dsc_validityperiod`

Data type: `Optional[Enum['Hours', 'Days', 'Months', 'Years']]`

Specifies the validity period of the certification authority certificate in hours, days, weeks, months or years. If this is a subordinate CA, do not use this parameter, because the validity period is determined by the parent CA.

##### `dsc_validityperiodunits`

Data type: `Optional[Integer[0, 4294967295]]`

Validity period of the certification authority certificate. If this is a subordinate CA, do not specify this parameter because the validity period is determined by the parent CA.

#### Parameters

The following parameters are available in the `dsc_xadcscertificationauthority` type.

* [`dsc_catype`](#dsc_catype)
* [`dsc_certfilepassword`](#dsc_certfilepassword)
* [`dsc_credential`](#dsc_credential)
* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_catype"></a>`dsc_catype`

namevar

Data type: `Enum['EnterpriseRootCA', 'EnterpriseSubordinateCA', 'StandaloneRootCA', 'StandaloneSubordinateCA']`

Specifies the type of certification authority to install. The possible values are EnterpriseRootCA,
EnterpriseSubordinateCA, StandaloneRootCA, or StandaloneSubordinateCA.

##### <a name="dsc_certfilepassword"></a>`dsc_certfilepassword`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Specifies the password for certification authority certificate file.

##### <a name="dsc_credential"></a>`dsc_credential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

To install an enterprise certification authority, the computer must be joined to an Active Directory Domain Services
domain and a user account that is a member of the Enterprise Admin group is required. To install a standalone
certification authority, the computer can be in a workgroup or AD DS domain. If the computer is in a workgroup, a user
account that is a member of Administrators is required. If the computer is in an AD DS domain, a user account that is a
member of Domain Admins is required.

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_xadcsonlineresponder"></a>`dsc_xadcsonlineresponder`

The DSC xAdcsOnlineResponder resource type.
Automatically generated from version 1.0.0.0

#### Properties

The following properties are available in the `dsc_xadcsonlineresponder` type.

##### `dsc_ensure`

Data type: `Enum['Present', 'Absent']`

Specifies whether the Online Responder feature should be installed or uninstalled.

#### Parameters

The following parameters are available in the `dsc_xadcsonlineresponder` type.

* [`dsc_credential`](#dsc_credential)
* [`dsc_issingleinstance`](#dsc_issingleinstance)
* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_credential"></a>`dsc_credential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

If the Online Responder service is configured to use Standalone certification authority, then an account that is a
member of the local Administrators on the CA is required. If the Online Responder service is configured to use an
Enterprise CA, then an account that is a member of Domain Admins is required.

##### <a name="dsc_issingleinstance"></a>`dsc_issingleinstance`

namevar

Data type: `Enum['Yes']`

Specifies the resource is a single instance, the value must be 'Yes'

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_xadcswebenrollment"></a>`dsc_xadcswebenrollment`

The DSC xAdcsWebEnrollment resource type.
Automatically generated from version 1.0.0.0

#### Properties

The following properties are available in the `dsc_xadcswebenrollment` type.

##### `dsc_caconfig`

Data type: `Optional[String]`

CAConfig parameter string. Do not specify this if there is a local CA installed.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

Specifies whether the Web Enrollment feature should be installed or uninstalled.

#### Parameters

The following parameters are available in the `dsc_xadcswebenrollment` type.

* [`dsc_credential`](#dsc_credential)
* [`dsc_issingleinstance`](#dsc_issingleinstance)
* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_credential"></a>`dsc_credential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

If the Web Enrollment service is configured to use Standalone certification authority, then an account that is a member
of the local Administrators on the CA is required. If the Web Enrollment service is configured to use an Enterprise CA,
then an account that is a member of Domain Admins is required.

##### <a name="dsc_issingleinstance"></a>`dsc_issingleinstance`

namevar

Data type: `Enum['Yes']`

Specifies the resource is a single instance, the value must be 'Yes'

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

